<?php
/*
            
   //  //  CANDY EDITOR  //  //  //  //  //           
    
     (c) Peter Fox  candy@vulpeculox.net                                  /^._   
                   ,___,--~~~~--' /'~   
       See home page at vulpeculox.net/candy                `~--~\ )___,)/'      
                       (/\\_  (/\\_     
         Version 0.95  17 July 2010
          
*/
define('VERSION','0.95');

require_once('dump.php');  //@@@

//
//
//   .oooooo.                          .o88o.  o8o                                                .    o8o                        
//  d8P'  `Y8b                         888 `"  `"'                                              .o8    `"'                        
// 888           .ooooo.  ooo. .oo.   o888oo  oooo   .oooooooo oooo  oooo  oooo d8b  .oooo.   .o888oo oooo   .ooooo.  ooo. .oo.   
// 888          d88' `88b `888P"Y88b   888    `888  888' `88b  `888  `888  `888""8P `P  )88b    888   `888  d88' `88b `888P"Y88b  
// 888          888   888  888   888   888     888  888   888   888   888   888      .oP"888    888    888  888   888  888   888  
// `88b    ooo  888   888  888   888   888     888  `88bod8P'   888   888   888     d8(  888    888 .  888  888   888  888   888  
//  `Y8bood8P'  `Y8bod8P' o888o o888o o888o   o888o `8oooooo.   `V88V"V8P' d888b    `Y888""8o   "888" o888o `Y8bod8P' o888o o888o 
//                                                  d"     YD                                                                     
//                                                  "Y88888P'           
//
 
define('JQUERY_PATH','jquery-1.6.1.min.js');   // where is jquery relative to here
define('PREVIOUS_PATH','safety');              // where are old versions stored
define('LOCAL_INFO_PATH','info');              // where cfgs and logs stored.  .htaccess protected
define('INTERNAL_PASSWORD','');                // Alternative password setting that doesn't require the use of
                                               // the pageInfo.txt file.  This applies to all pages and overrides
                                               // any setting in the pageInfo.txt file
define('MAX_UPLOAD_SIZE_MB',4);                // max size of link document file upload in Mb. 
define('MAX_IMG_SIZE_MB',2);                   // max size of image file upload in Mb. 
                                               //    NB you may need to adjust the php-ini configuration value for
                                               //    upload_max_filesize  see ini_set() and ini_get()
                                               //    Will die with suitable message if it isn't.  See below
//===================================================================================================================
// Warning for programmers.  Although we set max upload file sizes here, php.ini                             ====   =
// may well be set to a smaller value.  This test will DIE if this is the case                               ====   =
// Deal with this simply by editing php.ini or hacking the next line                                         ==== I =
// ini_set('upload_max_filesize','<your max in MB here>M');                                                  ==== M =
$umfStr = ini_get('upload_max_filesize');  // quite possibly something like "5M"                             ==== P =
$umfBytes = (is_numeric($umfStr)) ? $umfStr : 1048576 * substr($umfStr,0,-1);  //                            ==== O =
if(($umfBytes < (1048576 * MAX_IMG_SIZE_MB))||($umfBytes < (1048576 * MAX_UPLOAD_SIZE_MB))){  //             ==== R =
  die("PROGRAMMER! You need to look at <i>upload_max_filesize</i><br>Currently set at $umfBytes bytes"); //  ==== T =
}//                                                                                                          ==== A =
// The post_max_size MUST BE SET IN PHP.INI  (Don't forget to stop/restart server after edit)                ==== N =
$pmsStr = ini_get('post_max_size');  // quite possibly something like "4M"                                   ==== T =
$pmsBytes = (is_numeric($pmsStr)) ? $pmsStr : 1048576 * substr($pmsStr,0,-1);  //                            ====   =
if(($pmsBytes < (1048576 * MAX_IMG_SIZE_MB))||($pmsBytes < (1048576 * MAX_UPLOAD_SIZE_MB))){  //             ====   =
  die("PROGRAMMER! You need to edit <i>post_max_size</i> in php.ini<br>Currently set at $pmsBytes bytes"); //====   =
}//                                                                                                          ====   =
//===================================================================================================================
define('ALLOWED_EXTENSIONS','jpg/jpeg/doc/odt/docx/xls/pdf/txt/mid/zip/rtf');   // to go with a-tag links to binaries
define('JQ_DOC_READY','$(document).ready');    // This is the magic string that will tell us if the original
                                               // document is using jquery already.  If this appears in the original
                                               // the we don't add a link to jq and we put the in-line-editing jq stuff
                                               // inside the existing document ready function. 
define('SUPPORT_EMAIL','support@foo.bar.com'); // How users get tech support.  Appears on menu bar.
                                               // Leave blank to disable this feature.
define('CHANGE_NOTIFY_EMAIL','');              // Where to send an alert to say there is some editing going on.
                                               // Leave blank to disable.  Multiple addresses can be separated by
                                               // semi-colon.  eg. secretary@users.org;support@foo.com                                               
define('EMAIL_CHANGE_FROM','');                // This is the 'From' address if support is emailed when changes
                                               // are made.  For example candyEditor@mysite.org.  Leave blank to
                                               // disable this feature.
define('VERSION_DEPTH',5);                     // number of previous versions to stack
define('VERSION_DELAY',0.05);                  // hours before allowing a push down  2 is probably a good setting.
                                               // (A safety backup is made, and all previous pushed down the stack,
                                               // when the timestamp of the most recent previous safety copy
                                               // is older than this.  So a burst of edits together is only one session.
define('HTML_ENTS','ALL');                     // Characters that are to be converted to HTML entities (see section later) [D]
                                               // - Leave blank to only restore entities found in the original.
                                               // - Set to 'ALL' for for all possible entities (may be slow).
// Style for the edit link minature block that may be added to the plain page as a shortcut to the edit screen
// The switch for this is editlink=YES (or =NO) against a page in ../info/pageInfo.txt
define('EDIT_LINK_STYLE',"<style type=\"text/css\">  /* Candy Editor link from here to editor */
  a.goToInLineEdit {
    display:block;width:3px;height:3px;
    background-color:#ddd;
    cursor:crosshair;
  }
</style>\n");

// leave alone!  This is permanently inserted in head of live page to hide edx items
define(EDX_STYLE,".edx {display:none !important;} /* Candy Editor hidden items */");  

// This is permanently inserted into head of live page to make it more likely that the changes from
// editing will show up without having to do a manual page refresh.

define('META_NOCACHE','<meta http-equiv="expires" value="Thu, 24 Jun 2011 11:00:00 GMT"><meta http-equiv="pragma" content="no-cache">');




//
//  __         __                               __    __                       __  __                __    __               
// |__|.-----.|  |_ .-----..----..-----..---.-.|  |_ |__|.-----..-----..---.-.|  ||__|.-----..---.-.|  |_ |__|.-----..-----.
// |  ||     ||   _||  -__||   _||     ||  _  ||   _||  ||  _  ||     ||  _  ||  ||  ||__ --||  _  ||   _||  ||  _  ||     |
// |__||__|__||____||_____||__|  |__|__||___._||____||__||_____||__|__||___._||__||__||_____||___._||____||__||_____||__|__|
//
// Most internationalisation has to be done in-line 
// Look for "i18n" in the code
//
define('en_FAIL','FAIL');   // MUST match en_fail in the javascript

//error_reporting(E_ERROR | E_PARSE | E_NOTICE);  // don't want warnings reported as this will happen if upload is too large
error_reporting(0);  // don't want warnings reported as this will happen if upload is too large

//==============================================================
function FileExt($FullFileName){
// Return extension  eg gif
// Always lower case.  Convert "jpeg" to "jpg"
//==============================================================
  $b = basename($FullFileName);
  $a = explode('.',$b);
  $e = strtolower($a[1]);
  if($e=='jpeg'){$e='jpg';}
  return $e;
}



//
// ooooo                                      oooo        o8o               .o88o.           
// `888'                                      `888        `"'               888 `"           
//  888          .ooooo.   .ooooo.   .oooo.    888       oooo  ooo. .oo.   o888oo   .ooooo.  
//  888         d88' `88b d88' `"Y8 `P  )88b   888       `888  `888P"Y88b   888    d88' `88b 
//  888         888   888 888        .oP"888   888        888   888   888   888    888   888 
//  888       o 888   888 888   .o8 d8(  888   888        888   888   888   888    888   888 
// o888ooooood8 `Y8bod8P' `Y8bod8P' `Y888""8o o888o      o888o o888o o888o o888o   `Y8bod8P' 
//
// Parameters and logging
// ----------------------
// Access control file is a simple text file with password
// Log file is a simple timestamp/text file
// These are in LOCAL_INFO_PATH which should be protected with .htaccess
//



//==============================================================
function GetPageParameter($Page,$ParameterName){
// Look up access control file 
// this will have lines of the form somepage.htm pw=secret foo=bar
//==============================================================
  if(INTERNAL_PASSWORD != ''){            //| This is a hack where .htaccess
    if($ParameterName=='password'){       //| is not trusted.  This applies
      return INTERNAL_PASSWORD;           //| to all pages being edited in
    }                                     //| this directory.
  }                                       //|

  $rv = false;
  $scoredPage = str_replace('/','_',$Page);
  $pageInfo = file(LOCAL_INFO_PATH . '/pageInfo.txt',FILE_TEXT + FILE_IGNORE_NEW_LINES );
  foreach($pageInfo as $pi){                  // run through lines
    if(strpos($pi,'.htm ')!==false){          // ignoring blank/comments
      $bits = explode(' ',trim($pi));         // split into page and parameters
      if($Page==$bits[0]){                    // we have the specified page
        for($i=1;$i<count($bits);$i++){
          $infoa = explode(' ',trim($bits[$i]));  // each item is foo=bar
          foreach($infoa as $av){
            //print("[$av]");
            $ava=explode('=',$av);
            if($ava[0]==$ParameterName){
              $rv = $ava[1];
              break;
            }
          }  
        }
      }
    }
    if($rv){break;}
  }
  return $rv;  
}

//==============================================================
function WriteToLog($Page,$Message){
// Append message to the log file for this page
//==============================================================
  $pa = explode('.',$Page);
  $logFile = LOCAL_INFO_PATH . '/' . $pa[0] . '.log';
  $stamp = Date('d M Y H:i');
  $ip = $_SERVER['REMOTE_ADDR'];
  file_put_contents($logFile,"$stamp $ip $Message\n",FILE_APPEND+FILE_TEXT);
}



//
// oooooo     oooo                              o8o                                 
//  `888.     .8'                               `"'                                 
//   `888.   .8'    .ooooo.  oooo d8b  .oooo.o oooo   .ooooo.  ooo. .oo.    .oooo.o 
//    `888. .8'    d88' `88b `888""8P d88(  "8 `888  d88' `88b `888P"Y88b  d88(  "8 
//     `888.8'     888ooo888  888     `"Y88b.   888  888   888  888   888  `"Y88b.  
//      `888'      888    .o  888     o.  )88b  888  888   888  888   888  o.  )88b 
//       `8'       `Y8bod8P' d888b    8""888P' o888o `Y8bod8P' o888o o888o 8""888P' 
// 
// Versioning system.
//   sub-dirs called prev1...prev5 are used to store complete
//   images of the 'home' directory.  These are pushed down
//   each time we start editing from scratch.  We don't do
//   this if the latest previous version is less than two 
//   hours old.  When editing we can allow jumping to
//   view previous versions from the top bar.
// 
//   Note if there is more than one page in the home dir
//   they all get saved together  
//




//==============================================================
function DoVersionPush(){
//  Push all previous versions down 
//  See also TestToSeeIfWeWantToPushVersions()
//  Shifts previous versions by renaming directories
//  Copies 'all' files from home to 1st-last version directory
//==============================================================
  for($v=VERSION_DEPTH;$v>1;$v--){
    $d1 = PREVIOUS_PATH . '/prev' . (string)($v-1);   // from
    $d2 = PREVIOUS_PATH . '/prev' . $v;     // to
    if(file_exists($d2)){RemoveDir($d2);}
    if(file_exists($d1)){rename($d1,$d2);}
  }
  $d1 = PREVIOUS_PATH . '/prev1';
  @rmdir($d1);  // most recent
  mkdir($d1);  // (re)create most recent
  // copy all files from 'here' to d1
  if ($handle = opendir('.')) {
    while (false !== ($file = readdir($handle))) {
      if(! is_dir($file)){
        if(false==(stripos($file,'.php')||stripos($file,'.js')||stripos($file,'.css')||stripos($file,'.log'))){
          copy($file,$d1 . '/' . $file);
          //print("<br>Copy to $d1 / $file"); 
        }
      }
    }       
    closedir($handle);
  }
} 

//==============================================================
function RemoveDir($DirName){
//==============================================================
  if ($handle = opendir($DirName)) {
    while (false !== ($file = readdir($handle))) {
      if(! is_dir($file)){
        unlink($DirName . '/' . $file);
      }  
    }
    closedir($handle);
  }
  rmdir($DirName);
} 


//==============================================================
function TestToSeeIfWeWantToPushVersions(){
//  Yes if 1st prev version doesn't exist
//  or  it was created more than 'two' hours ago
//==============================================================
  $d1 = PREVIOUS_PATH . '/prev1';
  $rv = (file_exists($d1)==false);
  if(!$rv){
    $dirTime = filectime($d1);
    $rv = (($dirTime + (VERSION_DELAY * 3600))<time());
  }
  return $rv;
}


//==============================================================
function FindVersions($Page){
// return an array of previous versions of this page filenames
// age_of-version => full file name of original page
//==============================================================
  $rv = array();
  for($v=1;$v<=VERSION_DEPTH;$v++){
    $pvd = PREVIOUS_PATH . '/prev' . $v;    
    if(file_exists($pvd)){
      $created = date('j M y \a\t H:i',filectime($pvd));
      $rv[$v]=array($pvd . '/' . $Page,$created);
    }
  }  
  return $rv;
}



//==============================================================
function AddVersionHeaderToPage($Page){
// Add a version banner with changed info and links back
// to the editor to the just saves copy of the edited page
//==============================================================
  $p1PageName = PREVIOUS_PATH . "/prev1/" . $Page; 
  if(file_exists($p1PageName)){
    $html=file_get_contents($p1PageName,FILE_TEXT);  
    // add a banner describing the saving
    $script = $_SERVER['PHP_SELF'];
    $workingDir = dirname($script);
    
    $banner = "
    <div class=prevhead>Copy of $Page saved on " . date('j M y \a\t H:i:s')
      . " <a href=\"$workingDir/$Page\">View current</a>\n"
      . " <a href=\"$script" . "?page=$Page\">Edit current</a></div>\n";           //i18n
    $html = str_ireplace('<body>','<body>'.$banner,$html);
    
    // add style for the banner
    $bannerstyle = "
<style type=\"text/css\">  
  div.prevhead {
    position:fixed;top:0;background-color:olive;
    color:white;font-size:120%;font-weight:bold;
    text-align:center;width:100%;
  }
  div.prevhead a{
    text-decoration:none;
    color:blue;
    background-color:white;
    margin:0 1em;
  }
</style>\n";
    
    $html = str_ireplace('</head>',$bannerstyle.'</head>',$html);
  
    // write
    file_put_contents($p1PageName,$html);
  }  
}




//
//     _    _ _______ __  __ _                   _   _ _   _          
//    | |  | |__   __|  \/  | |                 | | (_) | (_)         
//    | |__| |  | |  | \  / | |        ___ _ __ | |_ _| |_ _  ___ ___ 
//    |  __  |  | |  | |\/| | |       / _ \ '_ \| __| | __| |/ _ | __|
//    | |  | |  | |  | |  | | |____  |  __/ | | | |_| | |_| |  __|__ \
//    |_|  |_|  |_|  |_|  |_|______|  \___|_| |_|\__|_|\__|_|\___|___/
//
//  When a source page contains an HTML entity such as &pound; it gets converted into a character
//  for screen display.  When we get the <body> returned to us at 'save' time all we have
//  is the character versions.  These must be converted back into entities before saving.
//  A bit of a bore because there are lots of possible entities.  There are more tedious
//  details: < and > (&gt; and &lt;) can't be searched and replaced en-masse but only in text.
//  Also we may come across & which needs converting into &amp; but only on its own and not
//  when it appears as part of an entity.
//
//  The define HTML_ENTITIES can be a fixed list of characters eg "&"
//  or 'ALL' in which case all possible character to entity substitutions will be tried
//  (which may be slow!)  If it is set to an empty string only entities found in the
//  original document will be replaced.
//
//  Greater-than and less-than
//  --------------------------
//  We have to deal with these in the client using javascipt.  DO NOT TRY TO SUBSTITUTE
//  them in HTML_ENTITIES as this won't work.
//
                                                                 

function CollectHTMLEntitiesFromSource($Html,&$ContainsGtLt){
// Return an array of HTML entities in the source HTML
// ContainsGtLt is true if the source contains either &gt; or &lt;
// eg array(''=>'&pound;','&'=>'&amp;')
// NB doesn't do numeric values
  $matches = array();
  preg_match_all('/&[A-Za-z][A-Za-z]+;/x',$Html,$matches,PREG_PATTERN_ORDER);  // Find entities in text
  $ents =  array_values(array_unique(array_values($matches[0])));              // Entities applicable to this text
  $c2e = array_intersect(get_html_translation_table(HTML_ENTITIES),$ents);     // All char=>entity
  $filteredC2e = array_diff($c2e,array('>'=>'&gt;','<'=>'&lt;'));              // weed < and >
  $ContainsGtLt = (count($c2e) > count($filteredC2e));
  return $filteredC2e;
}

function GetMapOfHtmlEntities($HtmlSource){
//  See discussion above
//  Either use HTML_ENTITIES, PHPs complete table or just ones in source
  if(HTML_ENTS == '') {
    $gtlt = false;
    return CollectHTMLEntitiesFromSource($HtmlSource,$gtlt);
  }  
  $rv = array_diff(get_html_translation_table(HTML_ENTITIES),array('>'=>'&gt;','<'=>'&lt;'));     // All char=>entity except < and >
  if(HTML_ENTS != 'ALL') {
    $he = HTML_ENTS;
    $a = array();
    for($i=0;$i<strlen($he);$i++){
      $c = $he[$i];
      $a[$c] = $c2e[$c];
    }
    $rv = $a;
  }
  // weed any entities we definitely don't want
  $weeds = '<>&"\'';
  for($i=0;$i<strlen($weeds);$i++){
    $c = $weeds[$i];
    if(array_key_exists($c,$rv)){unset($rv[$c]);}
  }
  return $rv;
}  

function ReplaceCharsWithEntities($Html,$CharsToEnt){
// Html may contain special characters we want to turn into entities
  $rv = $Html;
  dump::Trace($Html,'As received');
  if(count($CharsToEnt)>0){
    $rv = str_replace(array_keys($CharsToEnt),array_values($CharsToEnt),$rv);
  }
  return $rv;  
}

  





//
// ooo        ooooo            o8o                                             .                        
// `88.       .888'            `"'                                           .o8                        
//  888b     d'888   .oooo.   oooo  ooo. .oo.         .ooooo.  ooo. .oo.   .o888oo oooo d8b oooo    ooo 
//  8 Y88. .P  888  `P  )88b  `888  `888P"Y88b       d88' `88b `888P"Y88b    888   `888""8P  `88.  .8'  
//  8  `888'   888   .oP"888   888   888   888       888ooo888  888   888    888    888       `88..8'   
//  8    Y     888  d8(  888   888   888   888       888    .o  888   888    888 .  888        `888'    
// o8o        o888o `Y888""8o o888o o888o o888o      `Y8bod8P' o888o o888o   "888" d888b        .8'     
//                                                                                          .o..P'      
//                                                                                          `Y8P'       
//                                                                                                   
// We come here in a number of different cases
// 1  Called from scratch   ?page=foo.htm  
//       Possibly push versions
//       emit complete editable version of page
//
// 2  Called by the SAVE button to save all text  ?page=foo.htm
//       $_POST: pw=password 
//               newBody=edited html
//       stitch existing head onto new body after removing editing dross
//       emit suitable (not)OK message
//
// 3  Called by IMG editing ajax   ?page=foo
//       $_POST: pw=password
//               oldSrc=old image file name
//               uinput=new file uploaded
//       emit suitable (not)OK message
//
// 4  Called by A-TAG editing ajax   ?page=foo
//       $_POST: pw=password
//               aText= visible part of link (ignored - dealt with by jQuery)
//               aTitle= title attribute of link (ignored - dealt with by jQuery)
//               aInput = new file uploaded
//       emit suitable (not)OK message
//
//         
// AJAX responses (2,3,4) will either start with "OK" or "FAIL" possibly followed by a message.
// We will use this as the success/failure flag inside the client javascript
//         
// There is another possibility when the user tries to upload a file that is too large.
// I can't find a way to trap this so what happens is the warning is emitted then the
// 'from scratch' path is followed which means we output the page as if we were editing.
// The AJAX handler in the calling client script (js) will see neither OK nor FAIL
// but it will be able to see somewhere ' POST ' if it is this issue.  Otherwise it
// will need to display the first bit of the unexpected error/details message
//
//
define('FROM_SCRATCH',1);
define('FROM_SAVE',2);
define('FROM_IMG',3);
define('FROM_ATAG',4);
define('EOEHM',"<!-- END OF EDIT HEAD -->\n");   // we need this to add and chop
 
// 
// Read the page we are to work with from the command line
// 
$page=trim($_GET['page']);                    // read page to work with
$page=trim($page,'/');                        // remove naughty front and back slashes
if(stripos($page,'.htm')===false){$page='';}  // not html!     
if($page !=''){                                     // possibly a good file...
  if(! $html=file_get_contents($page,FILE_TEXT)){   // try reading
    $page='';                                       // may fail 
  }
}
if($page==''){die(en_FAIL . ' Page specified does not exist');}                    //i18n



// 
// How have we arrived here? (see 1..4 in description above)
// 
$because = FROM_SCRATCH;  // nothing posted
if(count($_POST)>0){      // see comment block above: Failed POSTING -> 0!
  // we always have the pw for password
  // look it up against the page parameters
  // throw a wobbly if incorrect
  if(GetPageParameter($page,'pw') != $_POST['pw']){
    WriteToLog($page,'FAIL Incorrect password');                                   //i18n
    die(en_FAIL . ' wrong password');
  } 
  // look at the sort of POST values to discover what calld us
  if(array_key_exists('newBody',$_POST)){
    $because = FROM_SAVE;
  }else{
    if(array_key_exists('oldSrc',$_POST)){
      $because = FROM_IMG;
    }else{
      if(array_key_exists('aText',$_POST)){
        $because = FROM_ATAG;
      }else{
        // can never happen
        WriteToLog($page,"FAIL God knows why we're here");                        //i18n
        die(en_FAIL . " God knows why we're here");                               //i18n
      }
    }
  }
}

// 
// Possibly stick safety copy on the previous versions stack
// Also a good time to let support know if we're monitoring changes
// 
if(TestToSeeIfWeWantToPushVersions()){
  DoVersionPush();
  AddVersionHeaderToPage($page);

  WriteToLog($page,'Saved on previous versions stack');                          //i18n
  if(EMAIL_CHANGE_FROM !=''){
    if(CHANGE_NOTIFY_EMAIL != ''){
      $editProgPage = $_SERVER['HTTP_HOST'] . $_SERVER['PHP_SELF'];   
      $editProgName = basename($editProgPage);
      $beingEdited  = str_replace($editProgName,$page,$editProgPage);
      $msg  = "Candy editor reports editing activity:\n";                        //i18n ...
      $msg .= "  When : " . Date('r') . "\n";
      $msg .= "  What : http://$beingEdited \n";
      $msg .= "  Who  : " .$_SERVER['REMOTE_ADDR'] . "\n";
      $msg .= "Note: This message is sent AT THE START of an editing session so you\nmay want to leave half an hour before reviewing the finished result.";
      WriteToLog($page,'Change alert sent to ' . CHANGE_ALERT_EMAIL);
      @mail(CHANGE_NOTIFY_EMAIL,"Page edit: $page",$msg,'From: ' . EMAIL_CHANGE_FROM . "\r\n");
    }
  }    
}

  
switch($because){
case  FROM_SAVE :
//      _____    __      ________   _______ ________   _________ 
//     / ____|  /\ \    / /  ____| |__   __|  ____\ \ / /__   __|
//    | (___   /  \ \  / /| |__       | |  | |__   \ V /   | |   
//     \___ \ / /\ \ \/ / |  __|      | |  |  __|   > <    | |   
//     ____) / ____ \  /  | |____     | |  | |____ / . \   | |   
//    |_____/_/    \_\/   |______|    |_|  |______/_/ \_\  |_|   
//
    // we want the new body
    $newHtmla = explode(EOEHM,$_POST['newBody'],2);   // [0] is our edit div  [1] is original body
    $newBody = "<body>\n" . $newHtmla[1] . "</body>\n</html>";
    // during our editing preparations we'll have added the contenteditable attribute
    // which we don't want carried across to the finished version.
    $newBody = str_replace(' contenteditable="true"','',$newBody);  

    // we want the old head
    $html = str_ireplace('<body>','<body>',$html);       // force tag to lower case...
    $oldHtmla = explode("<body>",$html,2);                // [0] is old <head>  [1] is old <body>
    $oldHead = $oldHtmla[0];  // includes </head>

    // substitute characters by html entities
    $c2e = GetMapOfHtmlEntities($oldHtmla[1]);   // may need old body to see what chars to use
    dump::Trace($c2e,'c2e');
    dump::Trace($newBody,'newBody');
    
    if(count($c2e)>0){$newBody = ReplaceCharsWithEntities($newBody,$c2e);}  // do the replacements
    
    // Do we have a link in the page to the editor?  If not then possibly add.
    if(GetPageParameter($page,'editlink')=='YES'){
      if(strpos($newBody,'class="goToInLineEdit"')===false){
        $newBody = str_replace("<body>\n",
          "<body>\n<a class=goToInLineEdit href=\"candyedit.php?page=$page\"></a>",
          $newBody);
      }
      // do we have the style for the edit link?  If not then possibly add it
      if(strpos($oldHead,'a.goToInLineEdit')===false){
        $oldHead = str_ireplace('</head>',EDIT_LINK_STYLE . '</head>',$oldHead);
      }
      
      // add the style for hiding edx items.
      if(strpos($oldHead,EDX_STYLE)==false){
        if(stripos($oldHead,'</style>')!==false){              // tidy method - inside existing style
          $oldHead = str_ireplace('</style>',EDX_STYLE . '</style>',$oldHead);
        }else{                                                 // no existing style so add own
          $oldHead = str_ireplace('</head>',"<style type=\"text/css\">" . EDX_STYLE . "</style>\n</head>",$oldHead);
        }        
      } 

      // add meta headers to prevent caching
      if(strpos($oldHead,META_NOCACHE)==false){
        $oldHead = str_ireplace('<head>',"<head>\n" . META_NOCACHE,$oldHead);
      }
    }    

    // write updates 
    file_put_contents($page,$oldHead . $newBody);
    WriteToLog($page,'Text updated');                      //i18n
    dump::Output('dump.htm');
    die('OK Saved');                                       //i18n
    break;

case FROM_IMG : 
//     _____ __  __          _____ ______ 
//    |_   _|  \/  |   /\   / ____|  ____|
//      | | | \  / |  /  \ | |  __| |__   
//      | | | |\/| | / /\ \| | |_ |  __|  
//     _| |_| |  | |/ ____ \ |__| | |____ 
//    |_____|_|  |_/_/    \_\_____|______|

  // what has been uploaded?
  extract($_FILES['uinput'],EXTR_PREFIX_ALL,'f'); // name, tmp_name,type,error,size
  // what was the original image?
  extract($_POST,EXTR_PREFIX_ALL,'p');  // oldSrc,page

  if($f_error){
    WriteToLog($page,"FAIL Image uploading error $p_oldSrc");                    //i18n
    die(en_FAIL . ' Uploading error');                                                 //i18n
  }else{
    if($f_size > (MAX_IMG_SIZE_MB*1024*1024)){
      WriteToLog($page,"FAIL Image size too large $f_name");                     //i18n
      die(en_FAIL . " File exceeds " . MAX_IMG_SIZE_MB . " Mbytes");                  //i18n
    }else{    
      if(FileExt($f_name)!=FileExt($p_oldSrc)){
        WriteToLog($page,"FAIL Image extension mismatch $p_oldSrc $f_name");     //i18n
        die(en_FAIL . "  Images must be replaced by same type");                       //i18n
      }else{
        // validation completed ok
        if(file_exists($p_oldSrc)){                           // log that we've now got a redundant image
          WriteToLog($page,"Image obsolete : $p_oldSrc");                        //i18n
        } 
        if(file_exists($f_name)){                             // log that we've overwritten an image
          unlink($f_name);
          WriteToLog($page,"Image replaced : $f_name");                          //i18n
        } 
        move_uploaded_file($f_tmp_name, $f_name);           
        WriteToLog($page,"Image uploaded : $f_name");                            //i18n
        die('OK');
      }
    }  
  }  
  break;
    
    
case FROM_ATAG :
//                _______       _____ 
//        /\     |__   __|/\   / ____|
//       /  \ ______| |  /  \ | |  __ 
//      / /\ \______| | / /\ \| | |_ |
//     / ____ \     | |/ ____ \ |__| |
//    /_/    \_\    |_/_/    \_\_____|
    
  // what has been uploaded?
  extract($_FILES['aInput'],EXTR_PREFIX_ALL,'f'); // name, tmp_name,type,error,size
  extract($_POST,EXTR_PREFIX_ALL,'p');  // aText,aTitle
  if($f_error){
    WriteToLog($page,"FAIL A-tag uploading error $f_name");                    //i18n
    die(en_FAIL . ' Uploading error');                                               //i18n
  }else{
    if($f_size > (MAX_UPLOAD_SIZE_MB*1024*1024)){
      WriteToLog($page,"FAIL Upload file too large $f_name");                  //i18n
      die(en_FAIL . " File exceeds " . MAX_UPLOAD_SIZE_MB . " Mbytes");              //i18n
    }else{    
      $fe = FileExt($f_name);
      $allowedExtensions = explode('/',ALLOWED_EXTENSIONS);
      if(! in_array($fe,$allowedExtensions)){
        WriteToLog($page,"FAIL Illegal A-tag file extension $f_name");         //i18n
        die(en_FAIL . " $fe is not an allowed file type");                           //i18n
      }else{
        // validation completed ok
        $warning = '';
        $fname = basename($f_name);
        if(file_exists($fname)){
          unlink($fname);
          WriteToLog($page,"File deleted : $fname");                                  //i18n
          $warning = "\nWARNING:\n Earlier version of $fname has been overwritten";   //i18n
        }  
        move_uploaded_file($f_tmp_name, $fname);           // 'overwrite' new
        WriteToLog($page,"File uploaded : $fname (Text=$p_aText)");                   //i18n
        die("OK $warning");
      }
    }
  }  
  break;   

    
case FROM_SCRATCH : 
//     ______ _____   ____  __  __    _____  _____ _____        _______ _____ _    _ 
//    |  ____|  __ \ / __ \|  \/  |  / ____|/ ____|  __ \    /\|__   __/ ____| |  | |
//    | |__  | |__) | |  | | \  / | | (___ | |    | |__) |  /  \  | | | |    | |__| |
//    |  __| |  _  /| |  | | |\/| |  \___ \| |    |  _  /  / /\ \ | | | |    |  __  |
//    | |    | | \ \| |__| | |  | |  ____) | |____| | \ \ / ____ \| | | |____| |  | |
//    |_|    |_|  \_\\____/|_|  |_| |_____/ \_____|_|  \_|_/    \_\_|  \_____|_|  |_|
//
//  This is where we have to wrap up the bare page with our editing paraphenalia
//  including links to jquery, style sheets and adding a menubar

  // 
  // Menu bar
  // 
  $pvfiles = FindVersions($page);  //array of previous file names  [n]=>(name,date)
  $prevList = '';
  foreach($pvfiles as $age=>$prevPage){
    $prevList .= " <a href=\"$prevPage[0]\" target=\"_blank\" title=\"$prevPage[1]\">$age</a> ";
  }
  $email = '';
  
  // ~~~~~~Start~~~of~~~i18n~~~~~~ 
  if(SUPPORT_EMAIL != ''){$email = "<a class=menuIcon href=\"mailto:" . SUPPORT_EMAIL . "\" title=\"Send email to support\" id=mail></a>";}
  $menuBar = "<body>
    <div class=\"menuBar\">
      <a class=menuIcon href=\"$page\" id=canx title=\"Cancel\"></a> 
      <DIV class=pageName>$page<span class=pw>Password <input id=pw name=password value=\"\" size=10 title=\"Password required\"></span></DIV>\t 
      <a class=menuIcon href=\"#\" title=\"Save\" id=save></a> 
      <a class=menuIcon href=\"#\" title=\"Instructions\" id=help></a> 
      $email
      <a class=menuButton href=\"#\" title=\"Clone copy earlier\"  id=buAddBefore></a> 
      <a class=menuButton href=\"#\" title=\"Clone copy later\"    id=buAddAfter></a> 
      <a class=menuButton href=\"#\" title=\"Delete this element\" id=buDelete></a> 
      <DIV class=fixedver>$prevList</DIV>\t 
    </div>";
  // NB \ts after /DIV are important \n after last /div is important

  $menuBar =  $menuBar. "<div id=debugs>Debugs:</div>\n";  // remove for public release

  // 
  // Help panel
  // 
  
  $techSupport = " your web page creator.";
  if(SUPPORT_EMAIL != ''){$techSupport = "<a href=\"mailto:" . SUPPORT_EMAIL . "\">$techSupport</a>";}
  
  $helpPanel = "<div id=helpPanel class=help>
  <ul>
  <li><img src=\"candyHelpType.gif\">Type on the candy-stripe areas to edit.
  <li><img src=\"candyHelpButton.gif\">Click on candy buttons to upload a replacement picture.<br>
      <span class=helpWarning>Maximum size of pictures is " . MAX_IMG_SIZE_MB . " Mb</span>
  <li><img src=\"candyHelpLink.gif\">Click on candy links to upload a replacement reference document (doc, pdf etc.)<br>
      <span class=helpWarning>Maximum size of uploads is " . MAX_UPLOAD_SIZE_MB . " Mb</span>
  <li><img src=\"candyHelpAdd.gif\">Some items can be cloned then edited.  Useful for lists that change.
  <li><img src=\"candyHelpDelete.gif\">Some items can be deleted.  The sole remaining one will only be hidden...
  <li><img src=\"candyHelpHidden.gif\">...Type on the grey stripes to revive a hidden item.
  <li><img src=\"candyHelpTick.gif\"><b>Always click on the green tick when you've finished</b>
  <li><small>Version " . VERSION . " Candy editor home page is at 
      <a target=\"_blank\" href=\"http://vulpeculox.net/misc/candy\">vulpeculox.net/misc/candy</a>
      For technical support contact $techSupport</small>
  </ul>
  <a id=helpCancel href=\"#\">Close help</a>
  </div>\n";
  
  // 
  // Dialog for image upload
  // 

  $imgForm  = "<div id=idiv class=dlg><div class=dlgMask> </div>
    <form id=\"iForm\" action=\"PLACEHOLDER\" method=\"post\" target=\"uframe\" enctype=\"multipart/form-data\">
      <div class=aFormHead>Upload a new picture</div>
                    <input id=iSrc type=hidden name=oldSrc value=\"PLACEHOLDER\">
                    <input id=iPw type=hidden name=pw value=\"PLACEHOLDER\">
      Pop-up hint:  <input id=iTitle name=aTitle size=49 value=\"\"><br>
      Upload file:  <input id=iFile name=uinput type=file size=40><br>
      <a id=iCanx href=\"#\" >Cancel</a> 
      <a id=iSave href=\"#\" >Commit change</a> 
    </form>
  </div>\n";  

  // 
  // Dialog for a-tag upload
  // 
  $aTagForm = "<div id=adiv class=dlg><div class=dlgMask> </div>
    <form id=\"aForm\" target=\"uframe\" action=\"PLACEHOLDER\" enctype=\"multipart/form-data\" method=\"post\">
       <div class=aFormHead>Link to an uploaded file</div>
                     <input id=aPw type=hidden name=pw value=\"PLACEHOLDER\">
       Display text: <input id=aText  name=aText  size=39 value=\"\"><br>
       Pop-up hint:  <input id=aTitle name=aTitle size=39 value=\"\"><br>
       <i>Reminder: Do not re-use file names unless you really want to overwrite.</i><br>
       Upload file:  <input id=aFile  name=aInput type=\"file\" size=\"30\"><br>
       <a id=aCanx href=\"#\" >Cancel</a> 
       <a id=aSave href=\"#\" >Commit change</a> 
    </form>
  </div>\n";

  // ~~~~~~end~~~of~~~i18n~~~~~~ 
  
  // 
  // iframe for receiving results of AJAX
  // 
  $iframe = "<iframe name=\"uframe\" id=\"uframe\"  src=\"about:none\" ></iframe><br>";   // BR is important

  $hidden = $helpPanel . $aTagForm . $imgForm . $iframe;
  
  // 
  // Insert our bits of html and jQuery
  // 
  $ileScriptTag = '<script src="candyedit.js" type="text/javascript"></script>';
  $jqScriptTag  = '<script src="' . JQUERY_PATH . '" type="text/javascript"></script>';   
  $ileStyleTag  = '<link href="candyedit.css" rel="stylesheet" type="text/css">';
  $editQueryCode = "candyEdit('$page');";                     // what we want to put in or add from scratch
  
  $html = str_ireplace(EDX_STYLE,'',$html);  // Remove edx hiding style used in real page

  $html = str_ireplace('<head>',"<head>\n  $ileScriptTag \n $ileStyleTag ",$html);  // always add our .js and .css
  
  // If the original page already has jQuery then we need to insert this inside the .ready()
  // function.  If not then we need to (a) wrap inside our ready() and (b) link to jquery library
  $usingJqAlready = (stripos($html,JQ_DOC_READY) !== false);   // test for already having doc ready hooked
  if(! $usingJqAlready){
    $html = str_ireplace('<head>',"<head>\n  $jqScriptTag",$html);  // link to jquery library needed
    // wrap js in complete ready function 
    $fullJq = "\n<script type=\"text/javascript\">\$(document).ready(function() { $editQueryCode });</script>\n";
    $html = str_ireplace('</head>',"$fullJq\n</head>",$html);  
  }else{    // we've already got some jquery so insert editing stuff into ready()
    $rfob = strpos($html,'{',$jqReadyPos) ;   // first curly after ready function call
    $html = substr($html,0,$rfob) . "\n$editQueryCode\n" . substr($html,$rfob);
  }  
  $html = str_ireplace('<body>',$menuBar . $hidden . EOEHM,$html);    // always do this for heading

  print($html);   // emit the complete page with all the bits
  
  break;
}// finish off master switch  

  
?>